﻿using System;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace TypyWartościoweIReferencyjne
{    
    using static Console;

    class Program
    {
        static void Main(string[] args)
        {
            int i = 1; //obiekt usunięty po wyjściu z zakresu
            int j = i; //klonowanie
            j = 2;

            WriteLine("i: " + i);
            WriteLine("j: " + j);

            //i = 2;
            WriteLine((i == j).ToString());
            WriteLine((i.Equals(j)).ToString());

            //------------------------

            Button b = new Button() { Text = "1" }; //obiekt usuwa GC
            Button c = b; //kopiowania referencji
            c.Text = "2";
            //b = null; GC.Collect();

            WriteLine("b: " + b.Text);
            WriteLine("c: " + c.Text);

            //b.Text = "2";
            WriteLine((b == c).ToString());
            WriteLine((b.Equals(c)).ToString());

            //------------------------

            string s = "1";
            string t = s;
            t = "2";

            WriteLine("s: " + s);
            WriteLine("t: " + t);

            //s = "2";
            WriteLine((s == t).ToString());
            WriteLine((s.Equals(t)).ToString());

            //------------------------

            StringBuilder sb = new StringBuilder();

            StreamReader sr = new StreamReader("C:\\config.sys");
            sr.Dispose(); //zasoby zewnętrzne (IDisposable)

            using (Button d = new Button())
            {
                sb.Append("1");
            };

            
        }
    }
}
